"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LazyLoadComponent = void 0;
const core_1 = require("@angular/core");
const docs_component_1 = require("../docs/docs.component");
let LazyLoadComponent = class LazyLoadComponent {
    constructor(cfr, compiler, injector, viewContainerRef, ngZone) {
        this.cfr = cfr;
        this.compiler = compiler;
        this.injector = injector;
        this.viewContainerRef = viewContainerRef;
        this.ngZone = ngZone;
    }
    /**
     * Unwrap a value which might be behind a closure (for forward declaration reasons).
     */
    maybeUnwrapFn(value) {
        return value instanceof Function ? value() : value;
    }
    insertComponent(components, veCfr) {
        this.viewContainerRef.clear();
        const cmpRefs = [];
        components.forEach((component) => {
            this.ngZone.run(() => {
                const componentFactory = (veCfr || this.cfr).resolveComponentFactory(component);
                const ref = this.viewContainerRef.createComponent(componentFactory);
                cmpRefs.push(ref);
            });
        });
        return cmpRefs;
    }
    insertModule(module) {
        const ngModuleFactory = this.compiler.compileModuleSync(module);
        const moduleRef = ngModuleFactory.create(this.injector);
        this.insertComponent(this.maybeUnwrapFn(moduleRef._bootstrapComponents), moduleRef.componentFactoryResolver);
    }
    insertDocs(template) {
        this.ngZone.run(() => {
            const cmpRefs = this.insertComponent([docs_component_1.DocsComponent]);
            const docsCmp = cmpRefs[0].instance;
            docsCmp.template = template;
        });
    }
    ngOnInit() {
        // window.onComponentLoad$.subscribe((component) => this.insertComponent([component]));
        // window.onModuleLoad$.subscribe((module) => this.insertModule(module));
        window.onDocsLoad$.subscribe((template) => this.insertDocs(template));
    }
    ngOnDestroy() {
        // window.onComponentLoad$.unsubscribe();
        // window.onModuleLoad$.unsubscribe();
        window.onDocsLoad$.unsubscribe();
    }
};
LazyLoadComponent = __decorate([
    (0, core_1.Component)({
        selector: 'app-lazy-load',
        template: ``
    })
], LazyLoadComponent);
exports.LazyLoadComponent = LazyLoadComponent;
//# sourceMappingURL=lazy-load.component.js.map